#include "ir.h"

IRData IR::data;
SoftwareSerial *IR::uart;

void IR::init()
{
  Serial.println("IR Init");
  data.mode = IR_MODE;
  data.count = IR_COUNT;
  if (IR_MODE == IRMode::IR_MODE_GPIO)
  {
    uint8_t pins[IR_COUNT] = IR_PINS;
    for (int i = 0; i < IR_COUNT; i++)
    {
      data.pins[i] = pins[i];
    };
  }
  else if (IR_MODE == IRMode::IR_MODE_UART)
  {
    uint8_t pins[2] = IR_PINS;
    data.pins[0] = pins[0];
    data.pins[1] = pins[1];
    uart = new SoftwareSerial(pins[0], pins[1]);
    uart->begin(IR_BAUD);
  }
}

void IR::update()
{
  if (data.mode == IRMode::IR_MODE_GPIO)
  {
    for (int i = 0; i < data.count; i++)
    {
      data.data[i] = digitalRead(data.pins[i]);
    }
  }
  else if (data.mode == IRMode::IR_MODE_UART)
  {
    if (uart->available())
    {
      data.data[0] = uart->read();
    }
  }
}